`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    08:04:12 02/03/2012 
// Design Name: 
// Module Name:    SPI_MASTER 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
//clock 25 mhz para el SPI
module SPI_MASTER(WRITE_READ,DATA_IN,DATA_OUT,CLK_SPI,SS_n,SLCK,MOSI,RDY,START,SPI_IDLE,MISO);

							/*			SS_n___SLCK___READY_____IDLE_____STATE*/
parameter IDLE				=  8'b1_______0_______0_________1______0000;
parameter WAIT				=  8'b0_______0_______0_________0______0001;
parameter CHARGE_MOSI	=  8'b0_______0_______0_________0______0010;
parameter WAIT2			=  8'b0_______0_______0_________0______0011;
parameter SET_CLOCK		=  8'b0_______1_______0_________0______0100;
parameter WAIT3			=  8'b0_______1_______0_________0______0101;
parameter READ_MISO		=  8'b0_______1_______0_________0______0110;
parameter CLEAR_CLOCK	=  8'b0_______0_______0_________0______0111;
parameter WAIT4			=  8'b0_______0_______0_________0______1000;
parameter WAIT5			=  8'b1_______0_______1_________0______1001;
parameter END				=  8'b1_______0_______1_________0______1010;

parameter OPCODE_READ	=	8'h0F;
parameter OPCODE_WRITE	= 	8'hF0;

input WRITE_READ;
input [23:0]DATA_IN;
input CLK_SPI;// 50MHZ

input START;// le dice al modul empiece la secuencia
output reg [7:0]DATA_OUT;// datos de respuesta que da el wiznet
output reg MOSI;
output SS_n;
output SLCK;

output RDY;
output SPI_IDLE;

input MISO;// entrada de datos

reg [7:0]SPI_STATE=IDLE;


reg [31:0]DATA_MOSI=32'd0;
reg [31:0]DATA_MISO=32'd0;
reg [4:0]count_data_shift=5'd31;


reg [31:0]DATA_OUT_MOSI=32'd0;//= WRITE_READ ? {OPCODE_WRITE,DATA_IN[23:0]}:{OPCODE_READ,DATA_IN[23:0]};

assign SS_n=SPI_STATE[7];
assign SLCK=SPI_STATE[6];

assign RDY=SPI_STATE[5];
wire RDY_DATA=SPI_STATE[5];
assign SPI_IDLE=SPI_STATE[4];


always@(posedge RDY_DATA)
begin
	DATA_OUT<=DATA_MISO[7:0];
end

always@(posedge CLK_SPI)
begin
	case(SPI_STATE)
		IDLE: begin
					if(START)
						begin
							SPI_STATE<=WAIT;
							MOSI<=1'b0;
							DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
							count_data_shift<=5'd31;
							DATA_OUT_MOSI<= WRITE_READ ? {OPCODE_WRITE,DATA_IN[23:0]}:{OPCODE_READ,DATA_IN[23:0]};
						end
					else
						begin
							SPI_STATE<=IDLE;
							DATA_OUT_MOSI<=DATA_OUT_MOSI;
							MOSI<=1'b0;
							DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
							count_data_shift<=5'd31;
						end
				end
		WAIT:	begin
					SPI_STATE<=CHARGE_MOSI;
					MOSI<=1'b0;
					DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
					count_data_shift<=count_data_shift;
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end
		CHARGE_MOSI:	
				begin
					MOSI<=DATA_OUT_MOSI[count_data_shift];
					SPI_STATE<=WAIT2;
					DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
					count_data_shift<=count_data_shift;
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end
		WAIT2:begin
					MOSI<=MOSI;
					SPI_STATE<=SET_CLOCK;
					DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
					count_data_shift<=count_data_shift;
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end		
		SET_CLOCK:begin
					MOSI<=MOSI;
					SPI_STATE<=WAIT3;
					DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
					count_data_shift<=count_data_shift;
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end
		WAIT3:begin
					MOSI<=MOSI;
					SPI_STATE<=READ_MISO;
					DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
					count_data_shift<=count_data_shift;
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end
		READ_MISO:begin
					MOSI<=MOSI;
					SPI_STATE<=CLEAR_CLOCK;
					DATA_MISO[count_data_shift]<=MISO;
					count_data_shift<=count_data_shift;
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end
		CLEAR_CLOCK:begin
					DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
					MOSI<=MOSI;
					SPI_STATE<=WAIT4;
					count_data_shift<=count_data_shift;
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end
		WAIT4:begin
					if(count_data_shift==0)
						begin
							SPI_STATE<=WAIT5;
							MOSI<=1'b0;
							count_data_shift<=5'd0;
							DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
							DATA_OUT_MOSI<=DATA_OUT_MOSI;
						end
					else
						begin
							count_data_shift=count_data_shift-1'b1;
							SPI_STATE<=CHARGE_MOSI;
							MOSI<=1'b0;
							DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
							DATA_OUT_MOSI<=DATA_OUT_MOSI;
						end
					
				end
		WAIT5:begin
					SPI_STATE<=END;
					MOSI<=1'b0;
					DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
					count_data_shift<=5'd0;
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end
		END:	begin
					SPI_STATE<=IDLE;
					MOSI<=1'b0;
					count_data_shift<=5'd0;
					DATA_MISO[count_data_shift]<=DATA_MISO[count_data_shift];
					DATA_OUT_MOSI<=DATA_OUT_MOSI;
				end
				
		default:begin
					SPI_STATE<=IDLE;
					MOSI<=1'b0;
					DATA_MISO[count_data_shift]<=1'b0;
					count_data_shift<=5'd0;
					DATA_OUT_MOSI<=32'd0;
				end
	endcase
end

endmodule
