
// --------------------------------------------------------------------
// Copyright (c) 2017 by FPGALOVER
// --------------------------------------------------------------------
//                     web: http://www.fpgalover.com
//                     email: admin@fpgalover.com or hbecerra@ece.ubc.ca
// --------------------------------------------------------------------
//	Author: Holguer Andres Becerra Daza
// Module: Simple W5100 module interface
// --------------------------------------------------------------------
#ifndef WIZNET5100_H_
#define WIZNET5100_H_

#include "altera_avalon_pio_regs.h"
#include "system.h"
#include <stdio.h>
#include <alt_types.h>
#include <string.h>
#include <stddef.h>
#include <stdint.h>
#include <ctype.h>
#include <sys/types.h>
#include <stdarg.h>


//ETHERNET WIZNET
#include "spi_functions.h"
#include "w5100.h"
#include "socket.h"
#include "dhcp.h"
#include "wsleep.h"



//Hardware

#define WIZNET_SPI_NAME ETHERNET_WIZNET_5100_0_BASE
#define RESET_REG_WIZNET5100_SPI 1
#define DATAOUT_REG_WIZNET5100_SPI 0
#define DATAIN_REG_WIZNET5100_SPI 2
#define IDLE_REG_WIZNET5100_SPI 3



#define WDELAY_CONSTANT 10
#define HOST_NAME   "fpgalover.com"
#define MAC_ADDRESS_W5100 0xEE,0x1d,0x96,0xdd,0x69,0x77
#define USE_DHCP 1

#if USE_DHCP<=0
#define STATIC_IP 192,168,1,77
#endif

#define _DHCP_SOCKET 0
#define _TCP_SOCKET 1
#define _HTTP_SOCKET 2

#define DHCP_DEBUG 0
#define HTTP_DEBUG 1
#define DEBUG_W5100 0
#define TCP_CLIENT_DEBUG 1
#define SOCKET_DEBUG 0

#define HTTP_SOCKET                     (_HTTP_SOCKET)                  /* Socket used in W5100 device */
#define HTTP_PORT                     (80)               /* HTTP Server Port, usually 80 */
#define HTTP_RX_BUFFER_SIZE               (1024)               /* Size of the buffer for incoming messages */
#define HTTP_TX_BUFFER_SIZE               (512)         /* Size of the buffer for replying messages (imposed by SD Card library) */
#define HTTP_SOCK_ESTABLISHED_TIMEOUT      (100)               /* Timeout used to disconnect the socket if nothing received from client */

#if USE_UCOSII>1
/* Scheduler includes. */
//OS includes
#include "includes.h"

/* Definition of Task Stacks */
#define TASK_STACKSIZE 2048
#endif

typedef struct {
	char CPU_state;
	/*hw & sw enables*/
	char _hw_status_enable_bluetooth_wifi_3g;
	char _hw_status_enable_bluetooth_wifi_3g_last;

	char _hw_status_enable_eth;
	char _hw_status_enable_eth_last;

	char _sw_status_enable_eth;
	char _sw_status_enable_eth_last;

	/*connection status*/
	unsigned char eth_status;
	unsigned char eth_status_last;
	/*System IP*/
	unsigned char ip[4];

	/*system websocket*/
	char _websocket_host_dir[100];
	char _restart_connection_wb;
} _NET_STATUS;

#endif /*WIZNET5100_H_*/
