#include "w5100.h"
#include "socket.h"
#include <stddef.h>
#include <stdint.h>
#include <ctype.h>
#include <sys/types.h>
#include <stdarg.h>

#define DELAY_WAIT_SEND 1000

unsigned char buffer_send[1024 * 3];
unsigned int Head_send_buffer = 0;
unsigned int tail_send_buffer = 0;

extern unsigned char _ip_[4];
extern unsigned short _port_;

void get_destination_address(SOCKET s, unsigned char * addr) {
	rd_Sn_DIPR(s, addr);

}

unsigned short get_destination_port(SOCKET s) {
	unsigned char destinationPORT[2];
	rd_Sn_DPORT(s, &destinationPORT[0]);
	return ((destinationPORT[0] << 8 )| (destinationPORT[1]));

}

void close_socket(unsigned char _s) /// funcion para cerrar socket abierto ya sea TCP o UDP
{

	//do{
	// enviamos el comando close al comand register Sn_CR
	if (!(write_wiznet(Sn_CR(_s), CR_CLOSE))) {
#if SOCKET_DEBUG>0
		printf("FATAL ERROR: Closing socket failed!\n");
#endif

	}
	// se espera mientras se limpia el reg S0_CR
	//}while(!(read_wiznet(Sn_CR(socket))==CR_CLOSE));
#if SOCKET_DEBUG>0
	printf("socket cerrado %d\n",read_wiznet(Sn_CR(socket)));
#endif
	putISR(_s, 0x00);
	write_wiznet(Sn_IR(_s), 0xFF);

}

void disconnect(unsigned char _s) {
	//if (_s != 0) return;
	//do{
	//printf("desconectando..\n");
	// Send Disconnect Command
	if (!(write_wiznet(Sn_CR(_s), CR_DISCON))) {
#if SOCKET_DEBUG>0
		printf("FATAL ERROR: Disconneting failed!\n");
#endif
	}
	//write_wiznet(Sn_CR(socket),CR_CLOSE);
	// Wait for Disconecting Process
	//}while(!(read_wiznet(Sn_CR(socket))==CR_CLOSE));
#if SOCKET_DEBUG>0
	printf("desconectado\n");
#endif

}

/******************************************************************************************

 Example:
 socket(0, MR_TCP, 8080); // open TCP socket at port 8080


 ******************************************************************************************/

unsigned char socket(SOCKET s, unsigned char protocolo, unsigned short puerto) // para TCP
{
	unsigned char valor_ret = 0;
	unsigned char open;

	// verificamos si el socket no esta cerrado
	if (!(read_wiznet(Sn_SR(s)) == SOCK_CLOSED)) {
		close_socket(s);
	}
	// Assigned Socket 0 Mode Register
	write_wiznet(Sn_MR(s), protocolo); /// protocolo: TCP, UDP o PPPoE
	setsockopt(s, TCP_NO_DELAY);

	// procedemos a abrir el Socket 0
	write_wiznet(Sn_PORT(s), ((puerto & 0xFF00) >> 8)); //direccion mas significativa del puerto
	write_wiznet(Sn_PORT(s) + 1, (puerto & 0x00FF));

//do{
	write_wiznet(Sn_CR(s), 0x01);           // abrimos el  Socket
	//  wsleep(1);
	//   open = ((read_wiznet(Sn_CR(socket))) & 0x01);
//}while(!(open==0x01)); // se espera mientras se abre el socket
#if SOCKET_DEBUG>0
	printf("Open!!!: %x\n", read_wiznet(Sn_CR(s)));
#endif
	//  while(read_wiznet(Sn_CR(socket)));

	// Check for Init Status
	if (read_wiznet(Sn_SR(s)) == SOCK_INIT) {
#if SOCKET_DEBUG>0
		printf("TCP");
#endif
		valor_ret = 1;
	} else if (read_wiznet(Sn_SR(s)) == SOCK_UDP) {
#if SOCKET_DEBUG>0
		printf("UDP");
#endif
		valor_ret = 1;
	}

	else {
		close_socket(s);
		valor_ret = 0;
	}

	return valor_ret;
}

/******************************************************************************************

 Ejemplo:
 /// direccion del servidor 192.168.2.9 y numero de puerto 8080
 Connect(0, 19216829, 8080); // abre un socket 0 con protocolo TCP y # de puerto 8080

 ******************************************************************************************/

unsigned char connect(unsigned char _s, unsigned char *addr,
		unsigned short port) {

	unsigned char retval = 0;
	unsigned int _time_out_ = 0;

	if (((addr[0] == 0xFF) && (addr[1] == 0xFF) && (addr[2] == 0xFF)
			&& (addr[3] == 0xFF))
			|| ((addr[0] == 0x00) && (addr[1] == 0x00) && (addr[2] == 0x00)
					&& (addr[3] == 0x00)) || (port == 0x00)) {
		retval = 0;

	} else {
		// envio de IP & puerto

		///// Enviamos la direccion ip del servidor con el cual
		////  se establecera la comunicacin.
		write_wiznet(Sn_DIPR(_s) + 0, (*(addr + 0)));
		write_wiznet(Sn_DIPR(_s) + 1, *(addr + 1));
		write_wiznet(Sn_DIPR(_s) + 2, *(addr + 2));
		write_wiznet(Sn_DIPR(_s) + 3, *(addr + 3));

		/// envia numero de puerto para conexion del socket con el servidor
		write_wiznet(Sn_DPORT(_s), ((port & 0xFF00) >> 8));
		write_wiznet(Sn_DPORT(_s) + 1, ((port) & 0x00FF));

		// SI EL SOCKECT ESTA ABIERTO
		if (read_wiznet(Sn_SR(_s)) == SOCK_INIT) {
			/// Se envia el comando de para establecer la conexion
			/// para esto se escribe en el Socket comand Register(S0_CR)
			/// el tipo de conexion TCP (cliente o servidor)
			/// para la conexion cliente se hace con el parametro CR_CONNECT y para servidor es CR_LISTEN
			unsigned char stado;
			stado = 0;
			write_wiznet(Sn_CR(_s), CR_CONNECT);
			stado = read_wiznet(Sn_SR(_s));
			wsleep(400050);
			if (((stado == 0x17))) {
				retval = 1;                // si no hay conexion y no responde
#if SOCKET_DEBUG>0
						printf("TCP conexion exitosa!\n");
#endif
			} else {
				retval = 0;                    // si conecta satisfactoriamente
			}

//                 //Se chequea si la conexion se establecio satisfactoriamente
//                 if (read_wiznet(Sn_SR(_s)) == SOCK_INIT)
//                 {
//                    retval=1;
//                 }
		} else {
			// abra socket, si no esta abierto jojo
			retval = 2;
		}

		return retval;

	}                    //// end else
} /// end function

unsigned short get_tx_base_addr(SOCKET s) {
	char _socket;
	_socket = s;
	if (_socket == 0)
		return 0x4000;
	else if (_socket == 1)
		return 0x5000;
	else if (_socket == 2)
		return 0x5800;
	else
		return 0x5C00;

}

unsigned short get_rx_base_addr(SOCKET s) {
	char _socket;
	_socket = s;
	if (_socket == 0)
		return 0x6000;
	else if (_socket == 1)
		return 0x7000;
	else if (_socket == 2)
		return 0x7800;
	else
		return 0x7C00;

}

unsigned short buf_mask_tx_rx(SOCKET s) {
	char _socket;
	_socket = s;
	if (_socket == 0)
		return BUF_MASK_4K;
	else if (_socket == 1 | _socket == 2)
		return BUF_MASK_2K;
}

unsigned char verify_network(SOCKET s) {
	unsigned char ret_val;
	unsigned char wiznet_stat;
	ret_val = 1;
	wiznet_stat = read_wiznet(Sn_SR(s));
	if (wiznet_stat == 0x00 || wiznet_stat == 0x01) {
#if SOCKET_DEBUG>0
		printf("servidor se ha caido... reconectando......stat=%x\n",wiznet_stat);
#endif
		//close_socket(s);
		socket(s, MR_TCP, 777);
		wsleep(9);
		ret_val = connect(s, _ip_, _port_);

	} else if (wiznet_stat == 0x15) {
		ret_val = 0;
	} else if (wiznet_stat == 0x17) {
		ret_val = 1;
	}

	return ret_val;
}

unsigned short sendF(SOCKET s, const char *fmt, ...) {
	char str[2048];
	size_t count;
	count = 500;
	size_t ret;
	va_list ap;

	va_start(ap, fmt);
	ret = vsnprintf(str, count, fmt, ap);
	va_end(ap);

	send(s, str, ret);
	return ret;
}

static const unsigned char endofline[] = "\r\n";
unsigned short sendln(SOCKET s, const char *fmt, ...) {
	char str[2048];
	size_t count;
	count = 500;
	size_t ret;
	va_list ap;

	va_start(ap, fmt);
	ret = vsnprintf(str, count, fmt, ap);
	va_end(ap);

	strcat(str, endofline);
	send(s, str, ret + 2);

	return ret;
}

unsigned short send(SOCKET s, unsigned char * buf, unsigned short buflen) {

	unsigned short ptr, offaddr, realaddr, txsize, TX_BUF_MASK, TXBUFADDR;

	unsigned short ret_val, ret;
	unsigned char wiznet_stat;
	int delay_timeout = 0;

	delay_timeout = 0;
	if (buflen > buf_mask_tx_rx(s))
		ret_val = buf_mask_tx_rx(s); // check size not to exceed MAX size.
	else
		ret_val = buflen;

	// if freebuf is available, start.
	do {
		txsize = read_wiznet(Sn_TX_FSR(s));
		txsize = (((txsize & 0x00FF) << 8) + read_wiznet(Sn_TX_FSR(s) + 1));

		wiznet_stat = read_wiznet(Sn_SR(s));
		if (delay_timeout++ > 1000) {

			return 0;
		}
		if ((wiznet_stat != SOCK_ESTABLISHED)
				&& (wiznet_stat != SOCK_CLOSE_WAIT)) {
			ret_val = 0;
			break;
		}

	} while (txsize < ret_val);
#if SOCKET_DEBUG>0
	printf("ready_to_Send %d\n",ret_val);
#endif

	TXBUFADDR = get_tx_base_addr(s);
	TX_BUF_MASK = buf_mask_tx_rx(s);
	ptr = read_wiznet(Sn_TX_WR(s));
	offaddr = (((ptr & 0x00FF) << 8) + read_wiznet(Sn_TX_WR(s) + 1)); //offset addr
	ret = ret_val;
#if SOCKET_DEBUG>0
	printf("[");
#endif
	while (ret > 0) {
		// Calculate the real W5100 physical Tx Buffer Address

		realaddr = TXBUFADDR + (offaddr & TX_BUF_MASK);

		// Se copian los datos en el buffer de Tx del W5100
		write_wiznet(realaddr, *buf);
#if SOCKET_DEBUG>0
		printf("%d,",*buf);
#endif
		offaddr++;
		buf++;
		ret--;

	}
#if SOCKET_DEBUG>0
	printf("]");
#endif
	write_wiznet((Sn_TX_WR(s)), (offaddr & 0xFF00) >> 8);
	write_wiznet((Sn_TX_WR(s) + 1), (offaddr & 0x00FF));

	// se envia el comando send par enviar los datos almacenados en el buffer
	if (!write_wiznet(Sn_CR(s), CR_SEND)) {
#if SOCKET_DEBUG>0
		printf("Packet was not sent\n");
#endif
	}
	// espera mientras se procesa el comando
	while (read_wiznet(Sn_CR(s)))
		;

	return ret_val;
}

unsigned short tam_rec(SOCKET s) {
	unsigned short size;
	size = read_wiznet(Sn_RX_RSR(s));
	size = (((size & 0x00FF) << 8) + read_wiznet(Sn_RX_RSR(s) + 1));
	return size;
}

unsigned char recv(SOCKET s, unsigned char * buf, unsigned short buflen) {
	unsigned short ptr, offaddr, realaddr, rxsize, RX_BUF_MASK, RXBUFADDR;
	//static  unsigned short rsr,i;

	if (buflen <= 0) {
		return 0;   ///si no hay nada en el buffer
	}

	RXBUFADDR = get_rx_base_addr(s);
	RX_BUF_MASK = buf_mask_tx_rx(s);

	/// tamao del paquete que llega ///
	rxsize = read_wiznet(Sn_RX_RSR(s));
	rxsize = (((rxsize & 0x00FF) << 8) + read_wiznet(Sn_RX_RSR(s) + 1));

	// si el tamao requerido sobrepasa el max del buffer el dato se truncara
	if (buflen > MAX_BUF) { // si la longitud de los datos recibidos saturan el buffer estos seran truncados al tmao del bffer
		buflen = MAX_BUF - 2;
	}
	// Read the Rx Read Pointer
	if (buflen <= MAX_BUF) {

		if (rxsize > 0) {
			ptr = read_wiznet(Sn_RX_RD(s));
			offaddr = (((ptr & 0x00FF) << 8) + read_wiznet(Sn_RX_RD(s) + 1));

			while (buflen) {
				buflen--;
				realaddr = RXBUFADDR + (offaddr & RX_BUF_MASK);
#if SOCKET_DEBUG>0
				printf("realaddr: %x\n", realaddr);
#endif
				*buf = read_wiznet(realaddr);
#if SOCKET_DEBUG>0
				printf("*buf: %c\n", *buf);
#endif
				offaddr++;
				buf++;

			}

			*buf = '\0';        // String terminated character
			write_wiznet(Sn_RX_RD(s), (offaddr & 0xFF00) >> 8);
			write_wiznet(Sn_RX_RD(s) + 1, (offaddr & 0x00FF));

			// Now Send the RECV command
			write_wiznet(Sn_CR(s), CR_RECV);
			wsleep(5);    // Wait for Receive Process

			return 1;

		}    ////end while

	}    ////end if
	return 0;
}    ////end function

unsigned char recieve(unsigned char _s) {
	unsigned char read_irq, ok;
	read_irq = read_wiznet(Sn_IR(_s) & 0x04);
	ok = read_irq;
	if (ok == 0x04)
		return 1;
	else
		return 0;
}

unsigned short sendto(SOCKET s, const unsigned char * buf,
		unsigned short buflen, unsigned char * addr, unsigned short port) {
	unsigned short ptr, offaddr, realaddr, txsize, timeout, TX_BUF_MASK,
			TXBUFADDR;
	unsigned char *remote_ip;
	remote_ip = &addr[0];

	if (buflen <= 0)
		return 0;

	TXBUFADDR = get_tx_base_addr(s);
	TX_BUF_MASK = buf_mask_tx_rx(s);

	// Make sure the TX Free Size Register is available
	txsize = read_wiznet(Sn_TX_FSR(s));
	txsize = (((txsize & 0x00FF) << 8) + read_wiznet(Sn_TX_FSR(s) + 1));

	//if (get_free_size < send_size);

	// Escribimos la IP y puerto destino
	//  Socket n Destination IP Address Register(Sn_DIPR)
	write_wiznet(Sn_DIPR(s) + 0, addr[0]);
	write_wiznet(Sn_DIPR(s) + 1, addr[1]);
	write_wiznet(Sn_DIPR(s) + 2, addr[2]);
	write_wiznet(Sn_DIPR(s) + 3, addr[3]);

	//Socket n Destination Port Register(Sn_DPORT).
	write_wiznet(Sn_DPORT(s), (port & 0xFF00) >> 8);
	write_wiznet(Sn_DPORT(s) + 1, (port & 0x00FF));

	timeout = 0;

	// Leemos el valor del puntero de escritura del W5100
	ptr = read_wiznet(Sn_TX_WR(s));
	offaddr = (((ptr & 0x00FF) << 8) + read_wiznet(Sn_TX_WR(s) + 1)); //offset addr

	while (buflen > 0) {
		// Calcula la direccion actual de escritura del buffer
		realaddr = TXBUFADDR + (offaddr & TX_BUF_MASK);
		// Se copia el dato a la memoria de TX del w5100
		write_wiznet(realaddr, *buf);
#if SOCKET_DEBUG>0
		printf("*********************buf %x\n", *buf );
#endif
		offaddr++;
		buf++;
		buflen--;

	}

	// se incrementa el  S0_TX_WR
	write_wiznet(Sn_TX_WR(s), (offaddr & 0xFF00) >> 8);
	write_wiznet(Sn_TX_WR(s) + 1, (offaddr & 0x00FF));

	// Se enva el comando e de envio del datagrama al w5100
	write_wiznet(Sn_CR(s), CR_SEND);

	//  while ( (read_wiznet(Sn_IR(s)) & SEND_OK) != SEND_OK )
	// Se epera el proceso de envio
	while (read_wiznet(Sn_CR(s)))
		;

	return 1;

}

/******************************************************************************************
 Descripcion: Funcin para leer o recibir datos en modo UDP los 8 primeros bytes del
 paquete corresponden al header de este en el cual los; los 4 primeros
 bytes corresponden a la dir IP del serv o cliente que envo el paquete
 los 2 bytes que siguen al numero de puerto y los ultimos 2 bytes son el
 tamao del paquete recibido.
 ------------------------------------------------------------------------------
 |IP Serv q envia         | Puerto del     | Tamao del paquete | DATOS         |
 |el paquete UDP (4 Bytes)| serv (2 Bytes) | de datos (2 Bytes) | RECIBIDOS ....|
 -------------------------------------------------------------------------------

 Ejemplo:
 /// por ej para recibir datos por el socket 1 (inicialmente se tuvo que abrir este socket )
 unsigned char svr_udp_addr[4];
 unsigned short svr_udp_port;
 unsigned short rec_size
 unsigned char dato_rx_udp[rec_size]
 rec_size=tam_rec(1);////tomammos el tamao del paquete recibido y lo mandamos a la funcion
 /// de recepcin para restringir la lect del buffer con el fin de no leer trash
 recvfrom(1, &dato_rx_udp, rec_size, &svr_udp_addr, &svr_udp_port);
 ******************************************************************************************/

unsigned short recvfrom(SOCKET s,  //< the socket number
		unsigned char * buf,    ///< a pointer to copy the data to be received
		unsigned short buflen,    ///< the data size to read
		unsigned char * addr,  ///< a pointer to store the peer's IP address
		unsigned short *port    ///< a pointer to store the peer's port number.
		) {
	unsigned char head[8];
	unsigned char head_size = 0x08;
	unsigned short data_len = 0;
	unsigned short ptr = 0;
	unsigned short rxsize, i = 0;
	unsigned short length_c, RX_BUF_MASK, RXBUFADDR;
	unsigned short offaddr, realaddr;

	length_c = buflen - head_size;

	if (buflen <= 0)
		return 0;   ///si no hay nada en el buffer

	RXBUFADDR = get_rx_base_addr(s);
	RX_BUF_MASK = buf_mask_tx_rx(s);
	/// tamao del paquete que llega ///
	rxsize = read_wiznet(Sn_RX_RSR(s));
	rxsize = (((rxsize & 0x00FF) << 8) + read_wiznet(Sn_RX_RSR(s) + 1));

	if (buflen > MAX_BUF) // si la longitud de los datos recibidos saturan el buffer estos seran truncados al tmao del bffer
		buflen = MAX_BUF - 2;
	// Read the Rx Read Pointer

	else {
		ptr = read_wiznet(Sn_RX_RD(s));
		offaddr = (((ptr & 0x00FF) << 8) + read_wiznet(Sn_RX_RD(s) + 1));

		///se guarda en un buffer el HEAD del paquete UDP
		while (head_size) {
			head_size--;
			realaddr = RXBUFADDR + (offaddr & RX_BUF_MASK); ///0x1FFF);//////////////////RX_BUF_MASK);
			head[i] = read_wiznet(realaddr);
			offaddr++;
			i++;
			if (head_size == 0x08) {
				i = 0;
				break;
			}
		}
		//   *head='\0';        // String terminated character
		// Now Send the RECV command
		//write_wiznet(Sn_CR(s),CR_RECV);
		// wsleep(5);    // Wait for Receive Process
		// offaddr += 8;

		addr[0] = (unsigned char) head[0];                       //[length-1];
		addr[1] = (unsigned char) head[1];                       //[length-2];
		addr[2] = (unsigned char) head[2];                       //[length-3];
		addr[3] = (unsigned char) head[3];                       //[length-4];

		*port = head[4];                       //[length-5];
		*port = (*port << 8) + head[5];                       //[length-6];
		data_len = head[6];                       //[length-7];
		data_len = (data_len << 8) + head[7];                      //[length-8];

		// read peer's IP address, port number.
#if SOCKET_DEBUG>0
		printf("UDP msg arrived\r\n");
		printf("source Port : %d\r\n", *port);
		printf("source IP : %d.%d.%d.%d\n", addr[0], addr[1], addr[2], addr[3]);
#endif
		//     if(data_len==length_c)
		//     {
		while (data_len) {
			data_len--;
#if SOCKET_DEBUG>0
			printf("bufflen %d\n", data_len);
#endif
			realaddr = RXBUFADDR + (offaddr & RX_BUF_MASK); //////////////////99999999999999RX_BUF_MASK);
#if SOCKET_DEBUG>0
					printf("realaddr: %x\n", realaddr);
#endif
			*buf = read_wiznet(realaddr);
#if SOCKET_DEBUG>0
			printf("*buf: %x\n", *buf);
			printf("*buf: %d\n", *buf);
#endif
			offaddr++;
			buf++;
#if SOCKET_DEBUG>0
			printf("buf: %x\n", *buf);
			printf("{%02x}", *buf);

			printf("RX Free Size: %d\n",rxsize);
			printf("length %d\n", length_c);
#endif
		}
		//  }
		*buf = '\0';        // String terminated characte
		///   else{printf("error de tamao del paquete de datos");}

		//                 printf("offaddr %x\n", offaddr);
		// Increase the S0_RX_RD value, so it point to the next receive
		write_wiznet(Sn_RX_RD(s), (offaddr & 0xFF00) >> 8);
		write_wiznet(Sn_RX_RD(s) + 1, (offaddr & 0x00FF));
		//          printf("Sn_RX_RD: %x%x\n",read_wiznet(Sn_RX_RD(s)),read_wiznet(Sn_RX_RD(s)+1));

		// return 0;

		write_wiznet(Sn_CR(s), CR_RECV);
		wsleep(5);
		//return *buf;
		while (read_wiznet(Sn_CR(s)))
			;

	}
#if SOCKET_DEBUG>0
	printf("recvfrom() end ..\r\n");
#endif
	return 1;
}

/**
 Esta funcion establece conexion en modo pasivo (servidor) espera
 el cliente para aceptarle la connexion y empezar la transferencia de datos
 */
unsigned char listen(SOCKET s /**< the socket number */
) {
	unsigned char ret;
#if SOCKET_DEBUG>0
	printf("listen()\r\n");
#endif

	if (read_wiznet(Sn_SR(s)) == SOCK_INIT) {
		write_wiznet(Sn_CR(s), CR_LISTEN);

		while (read_wiznet(Sn_CR(s)))
			;

		ret = 1;
	} else {
		ret = 0;
#if SOCKET_DEBUG>0
		printf("[ip invalida ,puerto invalido]\r\n");
#endif
	}
	return ret;
}

unsigned char setsockopt(SOCKET s, unsigned char opt) {
	unsigned char _state = 0;
	_state = read_wiznet(Sn_MR(s));

	if (opt == TCP_NO_DELAY) {
		/* se setea el estado de memoria del wiznet para enviar paquetes pequeos consecutivos
		 rapidamente por el protocolo tcp*/
		write_wiznet(Sn_MR(0), _state | 32);
	} else if (opt == TCP_NAGLE) {
		/* se setea el estado de memoria del wiznet para enviar paquetes no muy pequeos
		 por el protocolo tcp*/
		write_wiznet(Sn_MR(0), _state & 0xdf);
	}

}
