#include "w5100.h"

#ifndef	_SOCKET_H_
#define	_SOCKET_H_


#define BUF_MASK_4K      0x0FFF   // Tx 4K Buffer Mask: para S0
#define BUF_MASK_2K      0x07FF    // TX 2K para S1
///#define BUF_MASK_1K      0x07FF   // TX 1K para S2

#define TCP_NO_DELAY    1
#define TCP_NAGLE       0


/*  Funcion que hace la apertura de Sockets TCP  o UDP para TCP esta destinado el socket 0
 *  de buffer TX y RX de 4K debido a que es de alta prioridad el envo de las seales 
 *  fisiologicas al servidor web, el socket 1 y 2 de 2K de buffer cada uno puede ser utilizado para UDP^
 *  o para TCP 
 * */
unsigned char verify_network(SOCKET s);
 
extern unsigned char socket(SOCKET s, unsigned char protocolo, unsigned short puerto); // inicializacion de un socket TCP o UDP

/*Funcion que realiza la desconexion con el servidor web*/
extern void disconnect(unsigned char _s);

/*Funcion que cierra un socket*/
extern void close_socket(unsigned char _s);

extern void get_destination_address(SOCKET s, unsigned char * addr) ;

unsigned short get_destination_port(SOCKET s) ;
/*Funcion que estable la conexion TCP con un servidor WEB*/
extern unsigned char connect(unsigned char _s, unsigned char *addr, unsigned short port);////unsigned char connect(unsigned char socket);

/*Funcion para establecer conexion en modo pasivo "server"*/
extern unsigned char listen(SOCKET s);	// Establish TCP connection (Passive connection)

/*Funcin que establece la direccin base para trnasmisin de un socket determinado*/
unsigned short get_tx_base_addr(SOCKET s);

/*Funcin que establece la direccin base para trnasmisin de un socket determinado*/
unsigned short get_rx_base_addr(SOCKET s);

/*Funcin que establece la mascara para TX Y RX esto depende del tamao de buffer
 * asignado a cada socket, en cual se asignaron de los tamaos de buffer de TX y RX de la siguiente manera
 * socket 0 : 4k y socket 1 y 2 2K
 */
unsigned short buf_mask_tx_rx(SOCKET s);


extern unsigned short sendF(SOCKET s,const char *fmt, ...);

extern unsigned short sendln(SOCKET s,const char *fmt, ...) ;

/*Funcion de envio de dAtos en modo TCP al servidor WEB*/
extern unsigned short send(SOCKET s, unsigned char * buf, unsigned short buflen); // Send data (TCP)

/*Funcion pra recivir datos del servidor WEB en mod TCP*/
extern unsigned char recv(SOCKET s, unsigned char * buf, unsigned short buflen);	// Receive data (TCP)

/*Funcion para enviar datops en modo UDP*/
extern unsigned short sendto(SOCKET s, const unsigned char * buf, unsigned short buflen, unsigned char * addr, unsigned short port); // Send data (UDP/IP RAW)

/*Funcion para recibir datos en modo UDP*/
extern unsigned short recvfrom(SOCKET s, unsigned char * buf, unsigned short buflen, unsigned char * addr, unsigned short  *port); // Receive data (UDP/IP RAW)

/*Funcion que determina el tamao del paquete recibido del servidor*/
extern unsigned short tam_rec(SOCKET s);

/*Funcion para habilitar el algoritmo nagle o desactivarlo en la transmision*/
extern unsigned char setsockopt(SOCKET s,unsigned char opt);

//send IGMP packet
//extern unsigned short igmpsend(SOCKET s, const unsigned char * buf, unsigned short len);

unsigned char recieve(unsigned char _s);

//extern unsigned short sendto9(SOCKET s, const unsigned char * buf, unsigned short len, unsigned char * addr, unsigned short port);
#endif
/* _SOCKET_H_ */
