// --------------------------------------------------------------------
// Copyright (c) 2017 by FPGALOVER
// --------------------------------------------------------------------
//                     web: http://www.fpgalover.com
//                     email: admin@fpgalover.com or hbecerra@ece.ubc.ca
// --------------------------------------------------------------------
//	Author: Holguer Andres Becerra Daza
// Module: Simple W5100 module interface
// --------------------------------------------------------------------
#include "spi_functions.h"
#include "system.h"
#include <sys/alt_timestamp.h>
#include <io.h>
#include "altera_avalon_pio_regs.h"

bool reset_wiznet(void) {

	IOWR(WIZNET_SPI_NAME, RESET_REG_WIZNET5100_SPI, 0);
	wsleep(10);

	IOWR(WIZNET_SPI_NAME, RESET_REG_WIZNET5100_SPI, 1);

	wsleep(20000);

	// SW Reset
	unsigned char data_read = spi_write(WIZNET_WRITE, 0, 1 << 7);
	if (data_read != 3) {
		return false;
	}

	wsleep(20000);

	return true;

}

unsigned char spi_write(unsigned char write_read, unsigned short addr,
		unsigned char _data) {

	unsigned int data_out;

	unsigned int concatenated_data = 0;
	if (write_read) {
		concatenated_data = (write_read << 24) | (addr << 8) | (_data);
	} else {
		concatenated_data = (addr << 8) | (_data);
	}

	// espero a que el el modulo spi este en rpeoso
	while (IORD(WIZNET_SPI_NAME, IDLE_REG_WIZNET5100_SPI) == 0)
		;
	/*envio datos a wiznet*/
	IOWR(WIZNET_SPI_NAME, DATAOUT_REG_WIZNET5100_SPI, concatenated_data);
	while (IORD(WIZNET_SPI_NAME, IDLE_REG_WIZNET5100_SPI) == 1)
		;
	while (IORD(WIZNET_SPI_NAME, IDLE_REG_WIZNET5100_SPI) == 0)
		;

	data_out = IORD(WIZNET_SPI_NAME, DATAIN_REG_WIZNET5100_SPI) & 0xff;
	return data_out;

}
