#include "tcp_client.h"
#include <stdio.h>

#include "socket.h"

//W5100 Configs
#include "W5100_configs.h"

#define IP_SERVER_ADDRESS 192,168,1,55
#define TCP_PORT_SERVER    9000

extern unsigned char _ip_[4];
extern unsigned short _port_;
static unsigned char ETHERNET_states;
static unsigned long _packets_send;
static unsigned char _time_out_tcp = 0;

unsigned char wsocket_tcp = 0;
unsigned int wsocket_tcp_local = 777;
unsigned int port_tcp = 0;

unsigned char tcp_server_address[4];

static unsigned char g_TCP_RecvMsgBuffer[HTTP_RX_BUFFER_SIZE];

int TCP_client_init(unsigned char wsocket, unsigned char *addr,
		unsigned int port) {
	wsocket_tcp = wsocket;
	port_tcp = port;
	tcp_server_address[0] = addr[0];
	tcp_server_address[1] = addr[1];
	tcp_server_address[2] = addr[2];
	tcp_server_address[3] = addr[3];
	close_socket(wsocket);
	ETHERNET_states = _INIT_SOCKET;
	_packets_send = 0;
	_time_out_tcp = 0;

}
void TcP_Client(void) {
	unsigned char _status_connect_ = 0;
	static char counter = 0;
	unsigned short s16RecvMsgSize;
	unsigned char u8SocketStatus;

	switch (ETHERNET_states) {

	case _INIT_SOCKET:
		ETHERNET_states = _INIT_SOCKET;
		if (socket(wsocket_tcp, MR_TCP, wsocket_tcp_local) == 0) {
			close_socket(wsocket_tcp);
			OSTimeDlyHMSM(0,0,0,10);


		} else {
			ETHERNET_states = _CONNECT_;
		}
		break;
	case _CONNECT_:
#ifdef TCP_CLIENT_DEBUG
		printf("conecting to IP %d.%d.%d.%d:%d\n", tcp_server_address[0],
				tcp_server_address[1], tcp_server_address[2],
				tcp_server_address[3], port_tcp);
#endif
		_status_connect_ = connect(wsocket_tcp, tcp_server_address, port_tcp);

		ETHERNET_states = _SEND_AND_RECIVE;
		if (_status_connect_ == 2)/*socket no abierto*/
		{
			ETHERNET_states = _INIT_SOCKET;
#ifdef TCP_CLIENT_DEBUG
			printf("Retrying to IP %d.%d.%d.%d:%d\n", tcp_server_address[0],
					tcp_server_address[1], tcp_server_address[2],
					tcp_server_address[3], port_tcp);
#endif
		} else {

#ifdef TCP_CLIENT_DEBUG
			printf("Connected to IP %d.%d.%d.%d:%d\n", tcp_server_address[0],
					tcp_server_address[1], tcp_server_address[2],
					tcp_server_address[3], port_tcp);
#endif

		}
		OSTimeDlyHMSM(0,0,0,10);

		break;
	case _SEND_AND_RECIVE:

		ETHERNET_states = _SEND_AND_RECIVE;

		setsockopt(wsocket_tcp, TCP_NO_DELAY);
		if (verify_network(wsocket_tcp) != 1) {
			/*if the Server  doesn't  respond, restar time out*/
			_time_out_tcp++;
			if (_time_out_tcp >= 30)/* 30 sec later*/
			{
				_time_out_tcp = 0;
				ETHERNET_states = _IN_TIME_OUT;

				close_socket(wsocket_tcp);

#ifdef TCP_CLIENT_DEBUG
				printf("The Server Doesn't Respond, trying again in 60 sec\n");
#endif

			}

		} else {
#ifdef TCP_CLIENT_DEBUG
			printf("Sending Message to the Server\n");
			printf("Counter: %d\n", counter);
#endif
			sendF(wsocket_tcp, "Counter: %d\n", counter);
			counter++;
			/*if the Server respond, restart time out*/
			_time_out_tcp = 0;

			//Checking if there is incoming data
			s16RecvMsgSize = tam_rec(wsocket_tcp);
			if (s16RecvMsgSize > 0) {
				unsigned char destinationIP[4];
				unsigned short destinationPort;
				get_destination_address(wsocket_tcp, &destinationIP[0]);
				destinationPort=get_destination_port(wsocket_tcp);
				//Check RX buffer
				recv(wsocket_tcp, &g_TCP_RecvMsgBuffer[0], s16RecvMsgSize);
#if TCP_CLIENT_DEBUG>0
				printf("Receiving Message From %d.%d.%d.%d:%d: %s\n",destinationIP[0], destinationIP[1],
						destinationIP[2], destinationIP[3],destinationPort, g_TCP_RecvMsgBuffer);
#endif
			}

		}

		break;
	case _IN_TIME_OUT:
		_time_out_tcp++;
		if (_time_out_tcp >= 30)/* 30 sec later try Again*/
		{
			TCP_client_init(wsocket_tcp, tcp_server_address, port_tcp);
			_time_out_tcp = 0;
			ETHERNET_states = _INIT_SOCKET;
#ifdef TCP_CLIENT_DEBUG
			printf("Trying Connect to the server...\n");
#endif

		}
		break;
	}
}
